﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
//using StringPair = System.Tuple<string, string>;

namespace TilingsConsole
{

    public class UnionFindNode
    {
        UnionFindNode parent;
        int rank;

        public UnionFindNode() //string value
        {
            parent = this;
            rank = 0;

        }

        public UnionFindNode Find()
        {
            if (parent != this)
            {
                parent = parent.Find();
            }

            return parent;
        }

        static public void Union(UnionFindNode u1, UnionFindNode u2)
        {
            UnionFindNode parent1 = u1.Find();
            UnionFindNode parent2 = u2.Find();

            if (parent1.rank < parent2.rank)
            {
                UnionFindNode switcher = parent1;
                parent1 = parent2;
                parent2 = switcher;
            }
            // Now we know parent1.rank >= parent2.rank

            parent2.parent = parent1;

            if (parent1.rank == parent2.rank)
                parent1.rank++;

        }


    }

    // To be corrected in future versions:
    // Currently, nothing prevents UnionFindNode<S> from being a parent of UnionFindNode<T>,
    //which makes little sense
    public class UnionFindNode<T> : UnionFindNode
    {
        public T Value { set; get; }

        public UnionFindNode(T value)
            : base()
        {
            Value = value;
        }

        new public UnionFindNode<T> Find()
        {
            return (base.Find() as UnionFindNode<T>);
        }
    }

    class StringEqualityComparer : IEqualityComparer<string>
    {


        public bool Equals(string x, string y)
        {
            return x == y;
        }

        public int GetHashCode(string obj)
        {
            int multiplier = 1;
            int sum = 0;

            foreach (char c in obj)
            {
                if (c == ',' || c == ';')
                    multiplier++;
                else
                    sum += ((int)c) * multiplier;
            }

            return sum;

        }
    }

    class StringPairEqualityComparer : IEqualityComparer<StringPair>
    {

        public bool Equals(StringPair x, StringPair y)
        {
            return ((x.Item1 == y.Item1) && (x.Item2 == y.Item2));
        }

        public int GetHashCode(StringPair obj)
        {
            int hash = 23;
            hash = hash * 31 + obj.Item1.GetHashCode();
            hash = hash * 31 + obj.Item2.GetHashCode();

            return hash;
        }
    }

   

    

}
